# PIC16C84 ASM(PASS 1) (by Y. Ikushima)
BEGIN{ 	FS = "[,\t ]+";	#tB[hEZp[^","A^uA󔒂w
		addr = 0; code = 0; lbl_no = 0; def_no = 0;
		j = 0; caddr = 0; err = 0;
		print ARGV[ARGC -1]; #\[Xt@C\
	 }
{
	gsub(/^[\t ]/,"");	#sɂ^uAXy[X폜

	code = 99;

	if ($1 == "")	{	next;	}	#󔒍s̃XLbv
	if ($1 == "/*")	{	next;	}	#Rgs̃XLbv

	if ($1 == "CLRF")	{	code = 12; }
	if ($1 == "MOVWF")	{	code = 12; }
	if ($1 == "ADDLW")	{	code = 12; }
	if ($1 == "ANDLW")	{	code = 12; }
	if ($1 == "CALL")	{	code = 12; }
	if ($1 == "GOTO")	{	code = 12; }
	if ($1 == "IORLW")	{	code = 12; }
	if ($1 == "MOVLW")	{	code = 12; }
	if ($1 == "RETLW")	{	code = 12; }
	if ($1 == "SUBLW")	{	code = 12; }
	if ($1 == "XORLW")	{	code = 12; }

	if (code == 12)	{
		d_l[j] = NR;	#Jgsԍ
		d_0[j] = 2;		#R}h{ ̐
		d_1[j] = addr;	#AhX
		d_2[j] = $1;	#R}h
		d_3[j] = $2;	#P
		addr += 1;		#AhXCNg
		j ++;			#z|C^CNg
		next;			#͍̓sǂ݁A擪s
	}

	if ($1 == "ADDWF")	{	code = 13; }
	if ($1 == "ANDWF")	{	code = 13; }
	if ($1 == "COMF")	{	code = 13; }
	if ($1 == "DECF")	{	code = 13; }
	if ($1 == "DECFSZ")	{	code = 13; }
	if ($1 == "INCF")	{	code = 13; }
	if ($1 == "INCFSZ")	{	code = 13; }
	if ($1 == "IORWF")	{	code = 13; }
	if ($1 == "MOVF")	{	code = 13; }
	if ($1 == "RLF")	{	code = 13; }
	if ($1 == "RRF")	{	code = 13; }
	if ($1 == "SUBWF")	{	code = 13; }
	if ($1 == "SWAPF")	{	code = 13; }
	if ($1 == "XORWF")	{	code = 13; }
	if ($1 == "BCF")	{	code = 13; }
	if ($1 == "BSF")	{	code = 13; }
	if ($1 == "BTFSC")	{	code = 13; }
	if ($1 == "BTFSS")	{	code = 13; }

	if (code == 13)	{
		d_l[j] = NR;
		d_0[j] = 3;
		d_1[j] = addr;
		d_2[j] = $1;
		d_3[j] = $2;
		d_4[j] = $3;
		addr += 1;
		j ++;
		next;
	}
	
	if ($1 == "CLRW")	{	code = 11; }
	if ($1 == "NOP")	{	code = 11; }
	if ($1 == "CLRWDT")	{	code = 11; }
	if ($1 == "RETFIE")	{	code = 11; }
	if ($1 == "RETURN")	{	code = 11; }
	if ($1 == "SLEEP")	{	code = 11; }

	if (code == 11)	{
		d_l[j] = NR;
		d_0[j] = 1;
		d_1[j] = addr;
		d_2[j] = $1;
		addr += 1;
		j ++;
		next;
	}

	if ($1 == "#LBL")	{
		d_check($2);	#Qd``FbN
		c_lbl[lbl_no] = $2;			#x
		addr_lbl[lbl_no] = addr;	#AhX
		lbl_no ++;					#xz|C^CNg
		next;
	}
	
	if ($1 == "#DEF")	{
		d_check($2);	#Qd``FbN
		c_def[def_no] = $2;		#`
		dd_def[def_no] = $3;	#u
		def_no ++;				#`z|C^CNg
		next;
	}

	if ($1 == "#ORG")	{
		addr = $2;				#AhX
		next;
	}

	#RtBO[VEq[Yihcj
	if ($1 == "#CNF")	{	printf("#CNF %s %s\n",$2,$3);	next;	}
	
	#f[^E
	if ($1 == "#DAT")	{	printf("#DAT %s %s\n",$2,$3);	next;	}

	#G[
	printf("%d ",NR);
	error_trap($1);		#G[
}

END{
	#x̃Xg
	for(i = 0 ; i < lbl_no ; i ++)	{
		printf("#LBL %s %d\n",c_lbl[i],addr_lbl[i]);
	}
	#`̃Xg
	for(i = 0 ; i < def_no ; i ++)	{
		printf("#DEF %s %s\n",c_def[i],dd_def[i]);
	}

	for(i = 0 ; i < j; i ++)	{
		printf("%d ",d_l[i]);	#sԍ̕\

		#R}h{P̏ꍇ
		if (d_0[i] == 1)	{
			printf("%d %s\n",d_1[i],d_2[i]);
		}
		#R}h{Q̏ꍇ
		if (d_0[i] == 2)	{
			f_def = -1;
			#`z(#DEF)ɂ邩mF
			for(k = 0 ; k < def_no ; k ++)	{
				if(d_3[i] == c_def[k])	{
					f_def = k;
					break;
				}
			}
			if(f_def == -1)	{
				f_lbl = -1;
				#`zɖꍇAx(#LBL)ɂ邩mF
				for(k = 0 ; k < lbl_no ; k ++)	{
					if(d_3[i] == c_lbl[k])	{
						f_lbl = k;
						break;
					}
				}
				if(f_lbl == -1)	{
					#xɖꍇ
					if (index(d_3[i],"#") == 1) {
						printf("%d %s %s\n",d_1[i],d_2[i],n_s(d_3[i]));
					} else {
						error_trap(d_3[i]);	#G[
					}
				} else {
					#xœo^Ăꍇ
					printf("%d %s %d\n",d_1[i],d_2[i],addr_lbl[f_lbl]);
				}
			} else {
				#`œo^Ăꍇ
				printf("%d %s %s\n",d_1[i],d_2[i],dd_def[f_def]);
			}
		}
		#R}h{Ȑꍇ
		if (d_0[i] == 3)	{
			f_def = -1;
			#P`zɂ邩mF
			for(k = 0 ; k < def_no ; k ++)	{
				if(d_3[i] == c_def[k])	{
					f_def = k;
					break;
				}
			}
			if(f_def == -1)	{
				f_lbl = -1;
				#P`zɖꍇAxɂ邩mF
				for(k = 0 ; k < lbl_no ; k ++)	{
					if(d_3[i] == c_lbl[k])	{
						f_lbl = k;
						break;
					}
				}
				if(f_lbl == -1)	{
					#Pxɖꍇ
					if (index(d_3[i],"#") == 1) {
						printf("%d %s %s ",d_1[i],d_2[i],n_s(d_3[i]));
					} else {
						error_trap(d_3[i]);	#G[
					}
				} else {
					#Pxœo^Ăꍇ
					printf("%d %s %d ",d_1[i],d_2[i],addr_lbl[f_lbl]);
				}
			} else {
				#P`œo^Ăꍇ
				printf("%d %s %s ",d_1[i],d_2[i],dd_def[f_def]);
			}

			f_def = -1;
			#Q`zɂ邩mF
			for(k = 0 ; k < def_no ; k ++)	{
				if(d_4[i] == c_def[k])	{
					f_def = k;
					break;
				}
			}
			if(f_def == -1)	{
				f_lbl = -1;
				#Q`zɖꍇAxɂ邩mF
				for(k = 0 ; k < lbl_no ; k ++)	{
					if(d_4[i] == c_lbl[k])	{
						f_lbl = k;
						break;
					}
				}
				if(f_def == -1)	{
					#Qxɖꍇ
					if (index(d_4[i],"#") == 1) {
						printf("%s\n",n_s(d_4[i]));
					} else {
						error_trap(d_4[i]);	#G[
					}
				} else {
					#Qxœo^Ăꍇ
					printf("%d\n",addr_lbl[f_lbl]);
				}
			} else {
				#Q`œo^Ăꍇ
				printf("%s\n",dd_def[f_def]);
			}
		}
	}
	
	if(err == 1) {
		exit(1);
	}
}
#G[o
function	error_trap(s){
	err = 1;
	printf("<-------- ERROR : [ %s ] ?\n",s);
}
#萔ʎq"#"̍폜
function	n_s(s){
	l = length(s) - 1;
	return(substr(s,2,l));
}
#Qd``FbN
function	d_check(s){
	for(i = 0 ; i < lbl_no ; i ++)	{
		if (s == c_lbl[i])	{
			printf("%d #LBL Œ`ς݂ł ",NR);
			error_trap(s);
		}
	}
	for(i = 0 ; i < def_no ; i ++)	{
		if (s == c_def[i])	{
			printf("%d #DEF Œ`ς݂ł ",NR);
			error_trap(s);
		}
	}
}
